/*********************************************/
/*       File name:  session.c               */
/*    Project name:  socket/mtalk            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <sys/types.h>
#include <signal.h>
#include <curses.h>
#define BUF_LEN 80

/* MpEBhẼTCY */
#define SEND_WIN_WIDTH 60
#define SEND_WIN_HEIGHT 1

/* MpEBhẼTCY */
#define RECV_WIN_WIDTH 60
#define RECV_WIN_HEIGHT 13

/* MpƎMp̃EBhE𕪂 */
static  WINDOW  *win_send, *win_recv;
static  WINDOW  *frame_send, *frame_recv;

/* ʐMp̕ϐ */
static  char    send_buf[BUF_LEN];  /* Mobt@ */
static  char    recv_buf[BUF_LEN];  /* Mobt@ */
static  int     session_soc;	  /* \Pbg     */
static  fd_set  mask;               /* selectp}XN */
static  int     width;              /* }XN̕ */

/* I̊֐ */
static void die();


/********************/
/* J֐Q */
/********************/

/*  ZbV̏  */
void session_init(int soc)
	/* soc  \Pbg */
{
	/* select p}XN̐ݒ    */
	session_soc = soc;
	width = soc+1;
	FD_ZERO(&mask);
	FD_SET(0, &mask);
	FD_SET(soc, &mask);

	/* curses ̏Ȃ  */
	initscr();
	signal(SIGINT, die);

	/* MpEBhEƘgB */
	frame_send = newwin( SEND_WIN_HEIGHT + 2, SEND_WIN_WIDTH + 2, 18, 0);
	win_send = newwin( SEND_WIN_HEIGHT, SEND_WIN_WIDTH, 19, 1);
	box(frame_send, '|', '-');
	scrollok(win_send, TRUE);
	wmove(win_send, 0,0);

	/* MpEBhEƘgB */
	frame_recv = newwin(RECV_WIN_HEIGHT + 2, RECV_WIN_WIDTH + 2, 0, 0);
	win_recv = newwin(RECV_WIN_HEIGHT, RECV_WIN_WIDTH, 1, 1);
	box(frame_recv, '|', '-');
	scrollok(win_recv, TRUE);
	wmove(win_recv, 0,0);

	/* [̕ύX */
	cbreak();
	noecho();

	/* EBhE̕\ */
	wrefresh(frame_recv);
	wrefresh(win_recv);
	wrefresh(frame_send);
	wrefresh(win_send);
}

/*  ZbṼC[v  */
void session_loop()
{
	int c;         /* L[{[h͕̓ */
	int flag=1;    /* [vptbO       */
	fd_set readOk; /* select ̃}XN          */
	int len = 0;	 /* send_buf ݈̌ʒu    */
	int i;         /* [vJE^           */
	int y,x;       /* W                     */
	int n;         /* MoCg             */


	while(1){
		/*  select ̑Oɖ readOk B */
		readOk = mask;
		select(width,(fd_set *)&readOk,NULL,NULL,NULL);

		/*  L[{[h̓͂肩H */
		if ( FD_ISSET(0, &readOk ) ){
			c = getchar();

			/* back space ̏ */
			if (c == '\b' ||  c == 0x10 || c==0x7F ){
				if (len == 0) continue;
				len--;
				getyx(win_send, y,x);
				wmove(win_send, y, x-1);
				waddch(win_send, ' ');
				wmove(win_send, y, x-1);
			}
			/* sőM */
			else if (c == '\n' || c=='\r'){
				send_buf[len++]='\n';
				write(session_soc,send_buf,len);

				/* Clearing the send window */
				wclear(win_send);
				len = 0;
			}
			/* ȊȌ */
			else{
				send_buf[len++]=c;
				waddch(win_send, c);
			}
			wrefresh(win_send);
		}

		/*  \PbgɃf[^肩H */
		if ( FD_ISSET(session_soc, &readOk ) ){
			n = read(session_soc, recv_buf, BUF_LEN);
			for(i=0; i<n; i++){
				waddch(win_recv, recv_buf[i]);
			}

			/* "quit" 󂯂I */
			if (strstr(recv_buf, "quit")!=NULL)
				flag=0;
			wrefresh(win_recv);

			/* Move cursor back to the send buffer */
			wrefresh(win_send);
		}


		if(flag == 0) break;
	}
	/* [𕜋ďI */
	die();
}


static	void	die()
{
	endwin();
	close(session_soc);
	exit();
}
