/*********************************************/
/*       File name:  sessionman.c            */
/*    Project name:  socket/race             */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/*  sessionman.c                   */
/*   [X̃ZbV}l[W  */

#include <stdio.h>
#include <sys/types.h>
#include "race.h"

#define MAX_DAMAGE 10

static	int soc[MAX_PLAYERS];              /* \Pbg̔z */
static	char name[MAX_PLAYERS][16];        /* v[̖Oz */
static  char p[MAX_PLAYERS * PLAYER_SIZE]; /* v[̏ */

static  fd_set  mask;   /* select̏p}XN */
static  fd_set  readOk; /* selecť           */
static  int     width;  /* ĎfBXNv^̕ */

static  int final;    /* ŏIXe[W     */
static  int num;      /* QҐ         */
static  int reached;  /* S[C */
static  int crashed;  /* NbV */

/* ʕ\ */
static  char g[MAX_PLAYERS * GRADE_SIZE];

/* C[v̉[` */
static  void	recv_data();
static  void	send_data();
static  void	ending();


/*  enter  maccept() ɓnR[obN֐ */
void enter(int i, int fd)
	/* i   Ggԍ  */
	/* fd  \Pbg      */
{
	int    len;
	static char *login_mesg="Your name?";
	char   mesg[32];

	soc[i] = fd;
	write(soc[i],login_mesg,11);
	read(soc[i], name[i],16);

	/* entry number ` */
	sprintf(mesg, "%d\n", i);
	write(soc[i], mesg, strlen(mesg) + 1);
	printf("[%d] %s\n", i, name[i]);
}


/*  ZbV̏ */
void sessionman_init(int n, int fin, int maxfd)
	/*   n      Q҂̐l         */
	/*   fin    Xe[W           */
	/*   maxfd  ő̃fBXNv^ */
{
	int i;
	static char mesg[10];

	num = n;
	final = fin;

	/* select ̂߂̃}XN  */
	width = maxfd + 1;
	FD_ZERO(&mask);
	FD_SET(0, &mask);
	for (i=0; i<num; i++)
		FD_SET(soc[i] , &mask);

	/* ZbVJñf[^Sɑ */
	sprintf(mesg, "%d %d\n", num, final);
	for (i=0; i<num; i++)
		write(soc[i], mesg, 10);
	reached = 0;
	crashed = 0;
}

/* ZbṼC[v  */
void sessionman_loop()
{
	while(reached + crashed < num){
		recv_data();
		send_data();
	}
	ending();
}


/************************/
/*  level 2 ̊֐  */
/************************/

/* M\ȂׂẴfBXNv^ǂ */
static void recv_data()
{
	int	i;

	readOk = mask;  /* }XN */
	select(width, &readOk, NULL, NULL, NULL);

	for(i=0; i<num; i++){
		if(FD_ISSET(soc[i],(fd_set *)&readOk)){

			/* iԖڂ̃v[MAi*PLAYER_SIZEItZbg
			 p̏ꏊɃf[^Rs[BRs[TCY PLAYER_SIZE */
			read(soc[i], &p[i * PLAYER_SIZE], PLAYER_SIZE);

			/* _[W̃`FbN */
			if(p[i * PLAYER_SIZE + DAMAGE] >= MAX_DAMAGE){
				g[(num-crashed-1) * GRADE_SIZE + ENTRYNUM] = i;
				strcpy(&g[(num-crashed-1)*GRADE_SIZE + ENTRYNAME] , name[i]);
				crashed++;
			}
			/* S[C̃`FbN */
			if(p[i * PLAYER_SIZE + STAGE] > final){
				g[reached * GRADE_SIZE + ENTRYNUM] = (char)i;
				strcpy(&g[reached * GRADE_SIZE + ENTRYNAME], name[i]);
				reached++;
			}

		}
	}
}


/* ׂẴf[^zM */
static void send_data()
{
	int	i;

	for (i=0; i<num; i++){
		if ( FD_ISSET(soc[i],&readOk ))
			write(soc[i], p, PLAYER_SIZE * num );
	}
}

/* I */
static void ending()
{
	int	i;

	for (i=0;i<num;i++)
		write(soc[i], g, GRADE_SIZE * num);

}
